All Classes Namespaces Functions Variables Pages
CustomBondForce Class Reference

This class implements bonded interactions between pairs of particles. More...

Inheritance diagram for CustomBondForce:

## Public Member Functions

def | getNumBonds
| getNumBonds(CustomBondForce self) -> int More...
def | getNumPerBondParameters
| getNumPerBondParameters(CustomBondForce self) -> int More...
def | getNumGlobalParameters
| getNumGlobalParameters(CustomBondForce self) -> int More...
def | getEnergyFunction
| getEnergyFunction(CustomBondForce self) -> std::string const & More...
def | setEnergyFunction
| setEnergyFunction(CustomBondForce self, std::string const & energy) More...
def | addPerBondParameter
| addPerBondParameter(CustomBondForce self, std::string const & name) -> int More...
def | getPerBondParameterName
| getPerBondParameterName(CustomBondForce self, int index) -> std::string const & More...
def | setPerBondParameterName
| setPerBondParameterName(CustomBondForce self, int index, std::string const & name) More...
def | addGlobalParameter
| addGlobalParameter(CustomBondForce self, std::string const & name, double defaultValue) -> int More...
def | getGlobalParameterName
| getGlobalParameterName(CustomBondForce self, int index) -> std::string const & More...
def | setGlobalParameterName
| setGlobalParameterName(CustomBondForce self, int index, std::string const & name) More...
def | getGlobalParameterDefaultValue
| getGlobalParameterDefaultValue(CustomBondForce self, int index) -> double More...
def | setGlobalParameterDefaultValue
| setGlobalParameterDefaultValue(CustomBondForce self, int index, double defaultValue) More...
def | addBond
| addBond(CustomBondForce self, int particle1, int particle2, vectord parameters) -> int More...
def | getBondParameters
| getBondParameters(CustomBondForce self, int index) More...
def | setBondParameters
| setBondParameters(CustomBondForce self, int index, int particle1, int particle2, vectord parameters) More...
def | updateParametersInContext
| updateParametersInContext(CustomBondForce self, Context context) More...
def | usesPeriodicBoundaryConditions
| usesPeriodicBoundaryConditions(CustomBondForce self) -> bool More...
def | __init__
| init(OpenMM::CustomBondForce self, std::string const & energy) -> CustomBondForce init(OpenMM::CustomBondForce self, CustomBondForce other) -> CustomBondForce More...
def | __del__
| del(OpenMM::CustomBondForce self) More...
Public Member Functions inherited from Force
def | __init__
def | __del__
| del(OpenMM::Force self) More...
def | getForceGroup
| getForceGroup(Force self) -> int More...
def | setForceGroup
| setForceGroup(Force self, int group) More...
def | usesPeriodicBoundaryConditions
| usesPeriodicBoundaryConditions(Force self) -> bool More...
def | __copy__
def | __deepcopy__

## Public Attributes

| this

## Detailed Description

This class implements bonded interactions between pairs of particles.

Unlike HarmonicBondForce, the functional form of the interaction is completely customizable, and may involve arbitrary algebraic expressions. It may depend on the distance between particles, as well as on arbitrary global and per-bond parameters.

To use this class, create a CustomBondForce object, passing an algebraic expression to the constructor that defines the interaction energy between each pair of bonded particles. The expression may depend on r, the distance between the particles, as well as on any parameters you choose. Then call addPerBondParameter() to define per-bond parameters, and addGlobalParameter() to define global parameters. The values of per-bond parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter(). Finally, call addBond() once for each bond. After a bond has been added, you can modify its parameters by calling setBondParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

As an example, the following code creates a CustomBondForce that implements a harmonic potential:

`CustomBondForce* force = new CustomBondForce("0.5*k*(r-r0)^2");`

This force depends on two parameters: the spring constant k and equilibrium distance r0. The following code defines these parameters:

``

    force->addPerBondParameter("k");
    force->addPerBondParameter("r0");

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, floor, ceil, step, delta, select. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise. select(x,y,z) = z if x = 0, y otherwise.

## Constructor & Destructor Documentation

def __init__ | ( |  | self,
|  |  | args
| ) |  |

init(OpenMM::CustomBondForce self, std::string const & energy) -> CustomBondForce init(OpenMM::CustomBondForce self, CustomBondForce other) -> CustomBondForce

Create a CustomBondForce.

Parameters

  energy | an algebraic expression giving the interaction energy between two bonded particles as a function of r, the distance between them

References simtk.openmm.openmm.stripUnits().

def __del__ | ( |  | self | ) |

del(OpenMM::CustomBondForce self)

References simtk.openmm.openmm.stripUnits().

## Member Function Documentation

def addBond | ( |  | self,
|  |  | args
| ) |  |

addBond(CustomBondForce self, int particle1, int particle2, vectord parameters) -> int

Add a bond term to the force field.

Parameters

  particle1 | the index of the first particle connected by the bond
  particle2 | the index of the second particle connected by the bond
  parameters | the list of parameters for the new bond

References simtk.openmm.openmm.stripUnits().

Referenced by Topology.createDisulfideBonds(), and Topology.createStandardBonds().

def addGlobalParameter | ( |  | self,
|  |  | args
| ) |  |

addGlobalParameter(CustomBondForce self, std::string const & name, double defaultValue) -> int

Add a new global parameter that the interaction may depend on.

Parameters

  name | the name of the parameter
  defaultValue | the default value of the parameter

References simtk.openmm.openmm.stripUnits().

def addPerBondParameter | ( |  | self,
|  |  | args
| ) |  |

addPerBondParameter(CustomBondForce self, std::string const & name) -> int

Add a new per-bond parameter that the interaction may depend on.

Parameters

  name | the name of the parameter

References simtk.openmm.openmm.stripUnits().

def getBondParameters | ( |  | self,
|  |  | args
| ) |  |

getBondParameters(CustomBondForce self, int index)

Get the force field parameters for a bond term.

Parameters

  index | the index of the bond for which to get parameters
  particle1 | the index of the first particle connected by the bond
  particle2 | the index of the second particle connected by the bond
  parameters | the list of parameters for the bond

References simtk.openmm.openmm.stripUnits().

def getEnergyFunction | ( |  | self,
|  |  | args
| ) |  |

getEnergyFunction(CustomBondForce self) -> std::string const &

Get the algebraic expression that gives the interaction energy for each bond

References simtk.openmm.openmm.stripUnits().

def getGlobalParameterDefaultValue | ( |  | self,
|  |  | args
| ) |  |

getGlobalParameterDefaultValue(CustomBondForce self, int index) -> double

Get the default value of a global parameter.

Parameters

  index | the index of the parameter for which to get the default value

References simtk.openmm.openmm.stripUnits().

def getGlobalParameterName | ( |  | self,
|  |  | args
| ) |  |

getGlobalParameterName(CustomBondForce self, int index) -> std::string const &

Get the name of a global parameter.

Parameters

  index | the index of the parameter for which to get the name

References simtk.openmm.openmm.stripUnits().

def getNumBonds | ( |  | self,
|  |  | args
| ) |  |

getNumBonds(CustomBondForce self) -> int

Get the number of bonds for which force field parameters have been defined.

References simtk.openmm.openmm.stripUnits().

def getNumGlobalParameters | ( |  | self,
|  |  | args
| ) |  |

getNumGlobalParameters(CustomBondForce self) -> int

Get the number of global parameters that the interaction depends on.

References simtk.openmm.openmm.stripUnits().

def getNumPerBondParameters | ( |  | self,
|  |  | args
| ) |  |

getNumPerBondParameters(CustomBondForce self) -> int

Get the number of per-bond parameters that the interaction depends on.

References simtk.openmm.openmm.stripUnits().

def getPerBondParameterName | ( |  | self,
|  |  | args
| ) |  |

getPerBondParameterName(CustomBondForce self, int index) -> std::string const &

Get the name of a per-bond parameter.

Parameters

  index | the index of the parameter for which to get the name

References simtk.openmm.openmm.stripUnits().

def setBondParameters | ( |  | self,
|  |  | args
| ) |  |

setBondParameters(CustomBondForce self, int index, int particle1, int particle2, vectord parameters)

Set the force field parameters for a bond term.

Parameters

  index | the index of the bond for which to set parameters
  particle1 | the index of the first particle connected by the bond
  particle2 | the index of the second particle connected by the bond
  parameters | the list of parameters for the bond

References simtk.openmm.openmm.stripUnits().

def setEnergyFunction | ( |  | self,
|  |  | args
| ) |  |

setEnergyFunction(CustomBondForce self, std::string const & energy)

Set the algebraic expression that gives the interaction energy for each bond

References simtk.openmm.openmm.stripUnits().

def setGlobalParameterDefaultValue | ( |  | self,
|  |  | args
| ) |  |

setGlobalParameterDefaultValue(CustomBondForce self, int index, double defaultValue)

Set the default value of a global parameter.

Parameters

  index | the index of the parameter for which to set the default value
  name | the default value of the parameter

References simtk.openmm.openmm.stripUnits().

def setGlobalParameterName | ( |  | self,
|  |  | args
| ) |  |

setGlobalParameterName(CustomBondForce self, int index, std::string const & name)

Set the name of a global parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

References simtk.openmm.openmm.stripUnits().

def setPerBondParameterName | ( |  | self,
|  |  | args
| ) |  |

setPerBondParameterName(CustomBondForce self, int index, std::string const & name)

Set the name of a per-bond parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

References simtk.openmm.openmm.stripUnits().

def updateParametersInContext | ( |  | self,
|  |  | args
| ) |  |

updateParametersInContext(CustomBondForce self, Context context)

Update the per-bond parameters in a Context to match those stored in this Force object. This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setBondParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-bond parameters. All other aspects of the Force (such as the energy function) are unaffected and can only be changed by reinitializing the Context. The set of particles involved in a bond cannot be changed, nor can new bonds be added.

References simtk.openmm.openmm.stripUnits().

def usesPeriodicBoundaryConditions | ( |  | self,
|  |  | args
| ) |  |

usesPeriodicBoundaryConditions(CustomBondForce self) -> bool

Returns whether or not this force makes use of periodic boundary conditions.

References simtk.openmm.openmm.stripUnits().

## Member Data Documentation

this

Referenced by System.__init__().

The documentation for this class was generated from the following file:

- openmm.py